
const Mainloop = imports.mainloop;
const AltTab = imports.ui.altTab;

let _originalSelect;

function _modifiedSelect() {
    let select = _originalSelect;
    return function (app, window, forceAppFocus) {
        select.apply(this, [app, window, false]);
        
        if (this._thumbnailTimeoutId != 0) {
            Mainloop.source_remove(this._thumbnailTimeoutId);
            this._thumbnailTimeoutId = 0;
            this._timeoutPopupThumbnails();
        }
        
        if (window == null) {
            window = 0;
            if (!this._thumbnails)
                this._timeoutPopupThumbnails();
            this._thumbnails.highlight(window, true);
        }
    };
}

function init(metadata) {
    _originalSelect = AltTab.AltTabPopup.prototype._select;
}


function enable() {
    AltTab.AltTabPopup.prototype._select = _modifiedSelect();
}

function disable() {
    AltTab.AltTabPopup.prototype._select = _originalSelect;
}

